/*
** Some support stuff for the routines generated by
** Joerg Arndt's FHT generator. This is a stripped down version
** of the stuff in his general routines.
**
** For full details, implementation, etc., see his FXT and HFLOAT
** packages.  www.jjj.de/
*/

#define SQRT12   0.70710678118654752440084436210484
#define SQRT2    1.414213562373095048801688724209698078569
#define MAX(x,y)     ((x)>(y)?(x):(y))
#define SWAP(x,y)    {double tmp=x; x=y; y=tmp;}
#define sumdiff2(s,d)  { double t=s-d; s+=d; d=t; }
#define sumdiff2_05(s,d)  { double t=(s-d)*0.5; s+=d; s*=0.5; d=t; }
#define sumdiff2_x(s,d,x)  { double t=(s-d)*x; s+=d; s*=x; d=t; }
#define sumdiff4(a,b,s,d)  { s=a+b; d=a-b; }
#define sumdiff4_05(a,b,s,d)  { s=(a+b)*0.5; d=(a-b)*0.5; }
#define sumdiff4_x(a,b,s,d,x)  { s=(a+b)*x; d=(a-b)*x; }
#define csqr2(u,v)  { double t=u*u-v*v; v*=(u+u); u=t; }
#define csqr4(a,b,u,v)  { u=a*a-b*b; v=a*b; v+=v; }
#define cmult4(c,s,u,v)  { double t=u*s+v*c; u*=c; u-=v*s; v=t; }
#define cmult6(c,s,c1,s1,u,v)  { u=c1*c-s1*s; v=c1*s+s1*c; }

/*
** If you need a simple scramble routine, this will do.

void
scramble(double *fr, unsigned long n)
{unsigned long m,j,k;

 for (m=1,j=0; m<n-1; m++)
   {
    for (k=n>>1; (!((j^=k)&k)); k>>=1) {}
    if (j>m)  SWAP(fr[m],fr[j]);
   }
}

*/


